# coding: utf-8

"""
    STACKIT Server Update Management API

    API endpoints for Server Update Operations on STACKIT Servers.

    The version of the OpenAPI document: 2.0
    Contact: support@stackit.de
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing_extensions import Self


class UpdatePolicy(BaseModel):
    """
    UpdatePolicy
    """  # noqa: E501

    default: Optional[StrictBool] = None
    description: Optional[StrictStr] = None
    enabled: Optional[StrictBool] = None
    id: Optional[StrictStr] = None
    maintenance_window: Optional[StrictInt] = Field(default=None, alias="maintenanceWindow")
    name: Optional[StrictStr] = None
    rrule: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = [
        "default",
        "description",
        "enabled",
        "id",
        "maintenanceWindow",
        "name",
        "rrule",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdatePolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdatePolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "default": obj.get("default"),
                "description": obj.get("description"),
                "enabled": obj.get("enabled"),
                "id": obj.get("id"),
                "maintenanceWindow": obj.get("maintenanceWindow"),
                "name": obj.get("name"),
                "rrule": obj.get("rrule"),
            }
        )
        return _obj
